# AbstractProtoClass Class Reference
[Common wrapper and helper classes]

Inheritance diagram for AbstractProtoClass:
[legend]

List of all members.

## Public Member Functions

| beginPrefetch ()
| skipObjectPrefetching (Identifiable $object)
| endPrefetch (array $objectList)
| getPropertyList ()
| getExpandedPropertyList ($prefix=null)
| getPropertyByName ($name)
| isPropertyExists ($name)
| makeForm ($prefix=null)
| fillQuery (InsertOrUpdateQuery $query, Prototyped $object)
| getMapping ()
| importPrimitive ($path, Form $form, BasePrimitive $prm, $object, $ignoreNull=true)
| exportPrimitive ($path, BasePrimitive $prm, $object, $ignoreNull=true)

## Static Public Member Functions

static | makeOnlyObject ($className, $array, $prefix=null)
static | completeObject (Prototyped $object)

## Protected Member Functions

| makePropertyList ()

## Private Member Functions

| forwardPrimitive ($path, Form $form=null, BasePrimitive $prm, $object, $ignoreNull=true)
| safePropertyGet ($name)

## Static Private Member Functions

static | fetchEncapsulants (Prototyped $object)
static | assemblyObject (Prototyped $object, $array, $prefix=null)

## Private Attributes

| $depth = 0
| $storage = array()
| $skipList = array()

## Detailed Description

Definition at line 15 of file AbstractProtoClass.class.php.

## Member Function Documentation

static AbstractProtoClass::assemblyObject | ( | Prototyped $ | object,
|  | $ | array,
|  | $ | prefix = `null` |
| ) |  |  | `[static, private]`

Definition at line 372 of file AbstractProtoClass.class.php.

References FetchStrategy::LAZY, MetaRelation::ONE_TO_ONE, and Prototyped::proto().

Referenced by makeOnlyObject().

Here is the call graph for this function:

AbstractProtoClass::beginPrefetch | ( |  | ) |

Returns:
  AbstractProtoClass

Definition at line 26 of file AbstractProtoClass.class.php.

static AbstractProtoClass::completeObject | ( | Prototyped $ | object | ) | `[static]`

Definition at line 129 of file AbstractProtoClass.class.php.

References fetchEncapsulants().

Here is the call graph for this function:

AbstractProtoClass::endPrefetch | ( | array $ | objectList | ) |

Definition at line 49 of file AbstractProtoClass.class.php.

References Assert::isEqual().

Here is the call graph for this function:

AbstractProtoClass::exportPrimitive | ( | $ | path,
|  | BasePrimitive $ | prm,
|  | $ | object,
|  | $ | ignoreNull = `true` |
| ) |  |  |

Definition at line 275 of file AbstractProtoClass.class.php.

References BasePrimitive::getValue(), MetaRelation::MANY_TO_MANY, MetaRelation::ONE_TO_MANY, and MetaRelation::ONE_TO_ONE.

Here is the call graph for this function:

static AbstractProtoClass::fetchEncapsulants | ( | Prototyped $ | object | ) | `[static, private]`

Definition at line 339 of file AbstractProtoClass.class.php.

References FetchStrategy::LAZY, MetaRelation::ONE_TO_ONE, and Prototyped::proto().

Referenced by completeObject().

Here is the call graph for this function:

AbstractProtoClass::fillQuery | ( | InsertOrUpdateQuery $ | query,
|  | Prototyped $ | object |
| ) |  |  |

Returns:
  InsertOrUpdateQuery

Definition at line 213 of file AbstractProtoClass.class.php.

References getPropertyList().

Here is the call graph for this function:

AbstractProtoClass::forwardPrimitive | ( | $ | path,
|  | Form $ | form = `null`,
|  | BasePrimitive $ | prm,
|  | $ | object,
|  | $ | ignoreNull = `true` |
| ) |  |  | `[private]`

Definition at line 412 of file AbstractProtoClass.class.php.

References Assert::isTrue().

Referenced by importPrimitive().

Here is the call graph for this function:

AbstractProtoClass::getExpandedPropertyList | ( | $ | prefix = `null` | ) | `[final]`

Definition at line 147 of file AbstractProtoClass.class.php.

References makePropertyList().

Here is the call graph for this function:

AbstractProtoClass::getMapping | ( |  | ) |

Definition at line 224 of file AbstractProtoClass.class.php.

References getPropertyList().

Here is the call graph for this function:

AbstractProtoClass::getPropertyByName | ( | $ | name | ) |

Returns:
  LightMetaProperty

Exceptions:

  | MissingElementException |

Definition at line 181 of file AbstractProtoClass.class.php.

References safePropertyGet().

Referenced by importPrimitive(), and ProtoDAO::processPath().

Here is the call graph for this function:

AbstractProtoClass::getPropertyList | ( |  | ) | `[final]`

Definition at line 134 of file AbstractProtoClass.class.php.

References makePropertyList().

Referenced by fillQuery(), getMapping(), and makeForm().

Here is the call graph for this function:

AbstractProtoClass::importPrimitive | ( | $ | path,
|  | Form $ | form,
|  | BasePrimitive $ | prm,
|  | $ | object,
|  | $ | ignoreNull = `true` |
| ) |  |  |

Definition at line 241 of file AbstractProtoClass.class.php.

References forwardPrimitive(), BasePrimitive::getName(), getPropertyByName(), Form::importValue(), and FetchStrategy::LAZY.

Here is the call graph for this function:

AbstractProtoClass::isPropertyExists | ( | $ | name | ) |

Definition at line 191 of file AbstractProtoClass.class.php.

References safePropertyGet().

Here is the call graph for this function:

AbstractProtoClass::makeForm | ( | $ | prefix = `null` | ) |

Returns:
  Form

Definition at line 199 of file AbstractProtoClass.class.php.

References Form::create(), and getPropertyList().

Here is the call graph for this function:

static AbstractProtoClass::makeOnlyObject | ( | $ | className,
|  | $ | array,
|  | $ | prefix = `null` |
| ) |  |  | `[static]`

Definition at line 124 of file AbstractProtoClass.class.php.

References assemblyObject().

Here is the call graph for this function:

AbstractProtoClass::makePropertyList | ( |  | ) | `[abstract, protected]`

Referenced by getExpandedPropertyList(), and getPropertyList().

AbstractProtoClass::safePropertyGet | ( | $ | name | ) | `[private]`

Definition at line 438 of file AbstractProtoClass.class.php.

Referenced by getPropertyByName(), and isPropertyExists().

AbstractProtoClass::skipObjectPrefetching | ( | Identifiable $ | object | ) |

Returns:
  AbstractProtoClass

Definition at line 37 of file AbstractProtoClass.class.php.

References Identifiable::getId().

Here is the call graph for this function:

## Member Data Documentation

AbstractProtoClass::$depth = 0`[private]`

Definition at line 17 of file AbstractProtoClass.class.php.

AbstractProtoClass::$skipList = array()`[private]`

Definition at line 19 of file AbstractProtoClass.class.php.

AbstractProtoClass::$storage = array()`[private]`

Definition at line 18 of file AbstractProtoClass.class.php.

The documentation for this class was generated from the following file:

- main/Base/AbstractProtoClass.class.php